<template>
  <div class="wp-12 wp-layout wp-layout--no-pad wp-layout--form">
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <div class="wp-12 wp-layout wp-layout--no-pad">
        <wp-input type="switch" v-model="category.allow_negative"
          label="Отрицательные баллы"/>
      </div>
      <wp-input class="wp-12" type="text" v-model="category.name"
        label="Название" placeholder="Введите название"/>
    </div>
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <button class="wp-button wp-button--margin-right" @click="submit">
        Сохранить изменения
      </button>
      <button v-if="isEditing" class="wp-button wp-button--delete" @click="remove">
        Удалить
      </button>
      <button class="wp-button wp-button--cancel" @click="$emit('close')">
        Отменить
      </button>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex';

import WpInput from '@/components/WpInput.vue';

export default {
  name: 'Category',
  components: {
    WpInput,
  },
  data() {
    return {
      category: {
        id: null,
        name: null,
        allow_negative: false,
      },
    };
  },
  props: {
    data: {
      type: Object,
      default: () => undefined,
    },
  },
  computed: {
    isEditing() {
      return !!this.$props.data;
    },
  },
  methods: {
    ...mapActions('organization', [
      'createCategory',
      'updateCategory',
      'deleteCategory',
    ]),
    submit() {
      if (this.$props.data) {
        this.edit();
      } else {
        this.add();
      }
    },
    async add() {
      try {
        this.category.id = undefined;
        await this.createCategory(this.category);
        this.$toasted.success('Категория создана');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
    async edit() {
      try {
        await this.updateCategory(this.category);
        this.$toasted.success('Категория изменена');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
    async remove() {
      try {
        await this.deleteCategory(this.category.id);
        this.$toasted.success('Категория удалена');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    if (this.$props.data) {
      this.category = Object.assign({}, this.$props.data);
    }
  },
};
</script>

<style></style>
